package com.heming.bluetoothprinter.view;
import com.bluetoothprinter_sp300.Constant.MessageConstant;
import com.bluetoothprinter_sp300.activity.BaseActivity;
import com.bluetoothprinter_sp300.bluetooth.BlueToothPrintFunction;
import com.bluetoothprinter_sp300.bluetooth.BluetoothService;
import com.example.demo.R;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.MediaStore;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.PopupMenu;
import android.widget.PopupMenu.OnMenuItemClickListener;
import android.widget.TextView;
import android.widget.Toast;


@SuppressLint("NewApi")
public class MainActivity extends BaseActivity implements OnClickListener
,OnMenuItemClickListener	 {

	private static final String TAG = "BluetoothPrint";
	private static final boolean D = true;
	private TextView mTitle;
	private ImageButton show;
	private EditText mOutEditText;
	 private Button mPrintButton;
	// 请求的代码
		private static final int REQUEST_PRINT_IMAGE = 5;
		public BlueToothPrintFunction BTFunction;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		mHandler = new Handler(){
			@Override
			public void handleMessage(Message msg) {
				switch (msg.what) {
				case MessageConstant.MESSAGE_STATE_CHANGE:
					switch (msg.arg1) {
					case BluetoothService.STATE_CONNECTED:
						mTitle.setText(R.string.title_connected_to);
						mTitle.append(mConnectedDeviceName);
						break;
					case BluetoothService.STATE_CONNECTING:
						mTitle.setText(R.string.title_connecting);
						break;
					case BluetoothService.STATE_LISTEN:
					case BluetoothService.STATE_NONE:
						mTitle.setText(R.string.title_not_connected);
						break;
					}
					break;
				case MessageConstant.MESSAGE_WRITE:
					byte[] writeBuf = (byte[]) msg.obj;
					
					  Log.i(TAG,"发送的:");
					  
					  for (byte write : writeBuf) { Log.i(TAG,write + ";"); }
					 
					
					break;
				case MessageConstant.MESSAGE_READ:
					byte[] readBuf = (byte[]) msg.obj;
					// 从有效字节缓冲区构建一个字符串
					String readMessage = new String(readBuf, 0, msg.arg1);
					Log.i(TAG,"收到的" + readMessage);
					// 从有效字节缓冲区构建一个字符串
					break;
				
				case MessageConstant.MESSAGE_DEVICE_NAME:
					// 保存连接设备的名字
					mConnectedDeviceName = msg.getData().getString(
							MessageConstant.DEVICE_NAME);
					Toast.makeText(getApplicationContext(),
							"连接到" + mConnectedDeviceName, Toast.LENGTH_SHORT)
							.show();
					break;
				case MessageConstant.MESSAGE_TOAST:
					Toast.makeText(getApplicationContext(),
							msg.getData().getString(MessageConstant.TOAST),
							Toast.LENGTH_SHORT).show();
					break;
				}

			}
		};
		super.onCreate(savedInstanceState);
		
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		setContentView(R.layout.main_view_classic);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE,
				R.layout.custom_title);
		BTFunction = new BlueToothPrintFunction(mHandler);
		initViews();
	
		 

	}

	
	private void initViews() {
		mTitle = (TextView) findViewById(R.id.title_left_text);
		mTitle.setText(R.string.app_name);
		mTitle = (TextView) findViewById(R.id.title_right_text);
		show = (ImageButton) findViewById(R.id.show);
		show.setOnClickListener(this);
		 mOutEditText = (EditText) findViewById(R.id.edit_text_out);
		 mPrintButton = (Button) findViewById(R.id.button_print);
		 mPrintButton.setOnClickListener(this);
	}

	

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.show:
			showMenu(show);
			break;
		case R.id.button_print:
			// 检查是在尝试连接
						if (mService.getState() != BluetoothService.STATE_CONNECTED) {
							Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT)
									.show();
							return ;
						}
			 String message = mOutEditText.getText().toString();
			 BTFunction.sendMessage(message);
			break;
		}
	}

	

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		if (D)
			Log.d(TAG, "onActivityResult" + resultCode);
		switch (requestCode) {
	
		
		case REQUEST_PRINT_IMAGE:
			if (resultCode == Activity.RESULT_OK) {
				Uri selectedImage = data.getData();
				String[] filePathColumn = { MediaStore.Images.Media.DATA };

				Cursor cursor = getContentResolver().query(selectedImage,
						filePathColumn, null, null, null);
				cursor.moveToFirst();

				int columnIndex = cursor.getColumnIndex(filePathColumn[0]);
				String picturePath = cursor.getString(columnIndex);
				cursor.close();
				Bitmap btmap = BitmapFactory.decodeFile(picturePath);
				
				BTFunction.printBmp(btmap,1,20,true,64,false);
				break;
			}
		}

	}

	
	@SuppressLint("NewApi")
	public void showMenu(View v) {
		System.out.println("show");
		PopupMenu popup = new PopupMenu(this, v);

		// This activity implements OnMenuItemClickListener
		popup.setOnMenuItemClickListener(this);
		popup.inflate(R.menu.activity_main);
		popup.show();
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// 从Menu资源中初始化Menu 返回true则弹出默认menu，false则不弹出Menu，须自定义
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.activity_main, menu);
		return true;
	}

	@Override
	public boolean onMenuItemClick(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.scan:
			// 启动DeviceListActivity，并等待返回
			connectBluetoothDevice();
			return true;
		case R.id.disconnect:
			disconnectBluetoothDevice();
			return true;
			
		case R.id.print_img:
			// 检查是在尝试连接
			if (mService.getState() != BluetoothService.STATE_CONNECTED) {
				Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT)
						.show();
				return false;
			}
			Intent intent = new Intent(
					Intent.ACTION_PICK,
					android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
			startActivityForResult(intent, REQUEST_PRINT_IMAGE);

			return true;
		
		case R.id.eixt:
			exitDialog();
			return true;
		
		}
		return false;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.scan:
			// 启动DeviceListActivity，并等待返回
			connectBluetoothDevice();
			return true;
		case R.id.disconnect:
			disconnectBluetoothDevice();
			return true;
		case R.id.print_img:
			// 检查是在尝试连接
			if (mService.getState() != BluetoothService.STATE_CONNECTED) {
				Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT)
						.show();
				return false;
			}
			Intent intent = new Intent(
					Intent.ACTION_PICK,
					android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
			startActivityForResult(intent, REQUEST_PRINT_IMAGE);

			return true;
		

		case R.id.eixt:
			exitDialog();
			return true;
		}
		return false;
	}

	public void exitDialog() {
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage("确定要退出吗?");
		builder.setTitle("提示");
		builder.setPositiveButton("确认",
				new android.content.DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						dialog.dismiss();
						android.os.Process.killProcess(android.os.Process
								.myPid());
					}
				});
		builder.setNegativeButton("取消",
				new android.content.DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						dialog.dismiss();
					}
				});
		builder.create().show();
	}

	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
			exitDialog();
			return false;
		}
		return false;
	}

	
}
